/*
    lm_use.h
    Copyright 1998, 1999 by Richard Dawe

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    ---

    Lan Manager DOS API functions header file.
*/

#ifndef __lm_use_h__
#define __lm_use_h__

/* --- Defines --- */

/* - Errors - */
#ifndef ENOBUFS
#define ENOBUFS 105 /* No buffer space */
#endif

/* - Buffers - */
#define LM_BUFSIZE  65536
#define LM_BUFPARAS (LM_BUFSIZE >> 4)

/* - Uses - */
#define LM_USE_TYPE_WILDCARD   -1
#define LM_USE_TYPE_DISK        0
#define LM_USE_TYPE_PRINT       1
#define LM_USE_TYPE_COM         2
#define LM_USE_TYPE_IPC         3

/* --- Typedefs --- */

/* - Uses - */
typedef struct {
    char  devname[10];      /* 9-bytes + null */
    short unc_off;
    short unc_seg;
} LM_USE_INFO_0 __attribute__((packed));

typedef struct {
    char  devname[10];      /* 9-bytes + null */
    short remotename_off;
    short remotename_seg;
    short passwd_off;
    short passwd_seg;
    short status;
    short type;
    long  padding;
} LM_USE_INFO_1 __attribute__((packed));

/* --- Globals --- */

extern int lm_bufsel;
extern int lm_bufseg;

/* --- Functions --- */

int lm_init (void);
int lm_uninit (void);

int lm_NetUseEnum (int level, void *buf, int buflen);
int lm_NetUseAdd (char *devname, char *remotename, char *passwd, int type);
int lm_NetUseDel (char *name, int force);
int lm_NetUseGetInfo (char *devname, int level, void *buf, int buflen);

#endif  /* __lm_use_h__ */
